#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    find_minmax({ 1, 2 }, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
}

TEST_CASE("Identical numbers") {
    double min = 0, max = 0;
    find_minmax({ 5, 5, 5 }, min, max);
    CHECK(min == 5);
    CHECK(max == 5);
}
TEST_CASE("Empty vector") {
    double min = 42, max = 42;
    find_minmax({}, min, max);
    CHECK(min == 42);
    CHECK(max == 42);
}
TEST_CASE("Single element") {
    double min = 0, max = 0;
    find_minmax({ 42 }, min, max);
    CHECK(min == 42);
    CHECK(max == 42);
}

TEST_CASE("Negative numbers") {
    double min = 0, max = 0;
    find_minmax({ -3, -1, -2 }, min, max);
    CHECK(min == -3);
    CHECK(max == -1);
}

